'****************************************************************************
'
'                   -= PBSOUND for PowerBASIC 3.0/3.2 =-
'                                Version 1.80
'
'
'                >>>   Quadromania PC - A PBSOUND game   <<<
'
'  entwickelt von Th.Gohel  Fido:      Thomas Gohel@2:2410/301.12
'                           InterNet:  support@pbsound.snafu.de
'                           Homepage:  http://www.snafu.de/~pbsound/
'
'  letztes Update 01.07.1996
'
'  Hinweis:
'
'***************************************************************************

$CPU 8086
$LIB HERC OFF
$LIB CGA OFF
$LIB EGA OFF
$LIB COM OFF
$LIB IPRINT OFF
$COMPILE EXE "QUADR180.EXE"

$INCLUDE "SBLASTER.H"                     ' PBSOUND Header File
SBDebug% = 0                              ' PBSOUND Debug Mode: Off
SBUseSpeaker% = 0                         ' internal Speaker: No

DIM VGAPalette(0:763) AS SHARED INTEGER
DIM VGABackup(0:763)  AS SHARED INTEGER
DIM FlagArray(1218)   AS SHARED BYTE
DIM Buffer(32000)     AS SHARED INTEGER
DIM Tempo(32000)      AS SHARED INTEGER
DIM Welcome(32000)    AS SHARED INTEGER

SHARED VGAPalette(), VGABackup()
SHARED PalettenMax%
SHARED BildHMin%, BildHMax%, BildVMin%, BildVMax%
SHARED HFeld%, VFeld%
SHARED MausFlag%
SHARED MausH%, MausV%, MausKlick%, MausDoppel%, MausRightButton%
SHARED Dummy%, A$, FlagFeld$, InitStart%
SHARED Zug%, ZuegeGes%, Spielfarbe%, Schwierig%
SHARED Author$, Version$

PalettenMax% = 255
FlagFeld$    = STRING$(1218,1)
C%           = 4                         ' Center
BildHMin%    = 0   + C%
BildHMax%    = 630 + C%
BildHGes%    = 639
BildVMin%    = 16  + C%
BildVMax%    = 451 + C%
BildVGes%    = 479
Spielstark%  = 3
Spielfarbe%  = 3
Zug%         = 0

Version$ = "Version 0.43"
Author$  = "Th.Gohel

'**************************************************************************
'    Prepare Game
'**************************************************************************

' Commandline parameters

        Parameter$ = UCASE$(COMMAND$)
        IF INSTR(1,Parameter$,"/H") OR INSTR(1,Parameter$,"/?") > 0 THEN
            Hilfe
            END
        END IF
        IF INSTR(1,Parameter$,"/S") > 0 THEN BildSound% = 1
        IF INSTR(1,Parameter$,"/MONO") > 0 THEN VGAMono% = 1

' Directories

        SBIniDir
        QDir$ = SBIniPfad$

        IF BildSound% = 0 THEN
           SBInit(32)
           SBVoiceVolume 32, 32
           SBMIDIVolume  24, 24
        END IF

' Test VGA card

        ! mov ax, &h1A00
        ! int &h10
        ! mov Dummy%, bl
        IF Dummy% <> 8 THEN
             TitelLeiste
             PRINT "Quadromania bentigt eine VGA-Karte (640*480*16), I'm so sorry"
             PRINT
             END
        END IF
        SCREEN 12
        IF VGAMono% > 0 THEN
            ! mov ax, &h101B
            ! mov bx, &h0000
            ! mov cx, 255
            ! int &h10
        END IF

'**************************************************************************
'    Quadromania Intro
'**************************************************************************

        MouseInit
        BackupPalette
        LoadFont SBIniPfad$ + "quadrom.fnt", 16

        DEF SEG = VARSEG(Buffer%(0))
        BLOAD QDir$ + "LOGO.PIC", VARPTR(Buffer%(0))
        DEF SEG = VARSEG(Welcome%(0))
        BLOAD QDir$ + "WELCOME.PIC", VARPTR(Welcome%(0))
Bildaufbau:
        SBMidiPlay(SBIniPfad$ + "quadro02.mid")
        VIEW (0,0)-(639,479),20
        COLOR 14, 12
        MouseView
        LINE (8,456) - (634,456),8
        LINE (8,457) - (634,457),8
        LINE (8,458) - (634,458),8
        LINE (8,459) - (634,459),8
        LINE (635,24) - (635,459),8
        LINE (636,24) - (636,459),8
        LINE (637,24) - (637,459),8
        LINE (638,24) - (638,459),8

        DEF SEG = VARSEG(Buffer%(0))
        PUT (40,0),Buffer%, PSET
        VIEW (BildHMin%, BildVMin%) - (BildHMax%, BildVMax%),1
        FOR i% = 0 TO BildVMax% STEP 15
            LINE (0,i%) - (BildHMax%,i%),15,BF
        NEXT i%
        FOR i% = 0 TO BildHMax% STEP 15
            LINE (i%,BildVMax%) - (i%,0),15
        NEXT i%
        FadingIn

Texte:
        GET (0,0) - (630,15), Buffer%
        MouseOn
        MenuFenster
        MenuWelcome
        MenuConfig

'************************************************************************
'
'   G A M E  -  R o u t i n e s
'
'************************************************************************

        Start
        Game
        GOTO Ende

SUB Start public
        InitStart% = 1
        MausKlick% = 0
        RANDOMIZE TIMER
        FOR i% = 1 TO ZuegeGes%
            HFeld% = INT(RND*40)+1
            VFeld% = INT(RND*27)+1
            ! call MalFeld
        NEXT i%
        LOCATE 30,1
        PRINT " Sie werden maximal"; (ZuegeGes% *(Spielfarbe%-1)) + Schwierig%;
        PRINT "Zge ttigen drfen"; TAB(49); "Ihre Zge"; Zug%;
        MouseOn
        InitStart% = 0
END SUB

SUB Game public
        DO
            Abfrage
        LOOP WHILE A$ <> CHR$(27)
END SUB

SUB Abfrage public
        IF SBMidiStatus% = 0 THEN SBMidiPlay(SBIniPfad$ + "quadro02.mid")
        IF FlagFeld$ = STRING$(1218,1) THEN
            Fertig
            Start
        ELSE
            Keypressed
            ! dec HFeld%
            ! dec VFeld%
            FlagFeld% = (HFeld% + 1 * (VFeld% * 42)) + 1
            IF MausKlick% = 1 THEN
                MouseOff
                ! call MalFeld
                MouseOn
            END IF
            IF Zug% > (ZuegeGes% * (Spielfarbe%-1)) + Schwierig% THEN
                Vorbei
                Start
            END IF
        END IF
END SUB

SUB Vorbei
        DiskLog
        MouseOff
        COLOR 15,12
        LOCATE 30,1
        SBVoicePlay(SBIniPfad$ + "quadro04.voc")
        PRINT " Sie haben zu lange gebraucht                                  ";
        MouseOn
        Keypressed
        IF A$=CHR$(27) THEN GOTO Ende
        TextKill
        VIEW (BildHMin%, BildVMin%) - (BildHMax%, BildVMax%)
        MenuFenster
        LOCATE 11,21
        PRINT "         Neue Spielstufe whlen"
        MenuConfig
        BildRefresh
END SUB

SUB Fertig public
        DiskLog
        MouseOff
        COLOR 15,12
        LOCATE 30,1
        SBVoicePlay(SBIniPfad$ + "quadro03.voc")
        PRINT " Herzlichen Glckwunsch Sie haben es geschafft !!             ";
        MouseOn
        FOR i% = 1 TO 64
            COLOR 12, i%
        NEXT i%
        COLOR 15,12
        Keypressed
        IF A$=CHR$(27) THEN GOTO Ende
        TextKill
        VIEW (BildHMin%, BildVMin%) - (BildHMax%, BildVMax%)
        MenuFenster
        LOCATE 11,21
        PRINT "Whlen Sie bitte eine neue Spielstufe !!"
        MenuConfig
        BildRefresh
END SUB

Ende:
        FadingOut
        SBDeInstall
        ScreenOut
        DEF SEG=&hb800
           POKE$ 0, STRING$(80*25,0)
        DEF SEG
        SCREEN 0
        ScreenOut
        DELAY 1
        PRINT: PRINT: PRINT
        Hilfe
        FadingIn
        END

SUB BildRefresh public
        VIEW (BildHMin%, BildVMin%) - (BildHMax%, BildVMax%)
        FOR i% = 0 TO 430 STEP 15
            PUT (0,i%),Buffer%, PSET
        NEXT i%
        Zug% = 0
        FlagFeld$ = STRING$(1218,1)
        IF A$ = CHR$(27) THEN GOTO Ende
END SUB


'***************************************************************************
'  Darstellungsroutinen fr die Felder
'***************************************************************************

        MalFeld:
        IF HFeld% < 1 OR HFeld% > 40 THEN
            ! retn
        END IF
        IF VFeld% < 1 OR VFeld% > 27 THEN
            ! retn
        END IF
        IF InitStart% = 0 AND SBAktiv% = 1 AND BildSound% = 0 THEN
            SBVoiceStop
            SBVoicePlay(SBIniPfad$+"quadro02.voc")
        END IF
        ! call Malen
        ! inc VFeld%
        ! call Malen
        ! dec HFeld%
        ! call Malen
        ! dec VFeld%
        ! call Malen
        ! dec VFeld%
        ! call Malen
        ! inc HFeld%
        ! call Malen
        ! inc HFeld%
        ! call Malen
        ! inc VFeld%
        ! call Malen
        ! inc VFeld%
        ! call Malen
        IF InitStart% = 0 THEN
            Zug% = Zug% + 1
            LOCATE 30, 58
            PRINT Zug%;
        END IF
        ! retn

        Malen:
        FlagFeld% = (HFeld%+1 * (VFeld%*42)) + 1
        Farbe% = ASC(MID$(FlagFeld$,FlagFeld%,1))

        IF Spielfarbe% = 2 THEN
            ' *** Farbmodus 2 ***
            IF Farbe% =  1 THEN
                Farbe% = 7
                ! jmp Malpixel
            END IF
            IF Farbe% =  7 THEN
                Farbe% = 1
                ! jmp Malpixel
            END IF
        ELSEIF SpielFarbe% = 3 THEN
            ' *** Farbmodus 3 ***
            IF Farbe% =  1 THEN
                Farbe% = 7
                ! jmp Malpixel
            END IF
            IF Farbe% =  7 THEN
                Farbe% = 11
                ! jmp Malpixel
            END IF
            IF Farbe% = 11 THEN
                Farbe% = 1
                ! jmp Malpixel
            END IF
        ELSE
            ' *** Farbmodus 4 ***
            IF Farbe% = 1  THEN
                Farbe% = 7
                ! jmp Malpixel
            END IF
            IF Farbe% = 7  THEN
                Farbe% = 11
                ! jmp Malpixel
            END IF
            IF Farbe% = 11 THEN
                Farbe% = 3
                ! jmp Malpixel
            END IF
            IF Farbe% = 3  THEN
                Farbe% = 1
                ! jmp Malpixel
            END IF
        END IF

        Malpixel:
        VIEW (HFeld%*15+BildHMin%+1, VFeld%*15+BildVMin%+1) - ((HFeld%*15)+14+BildHMin%, (VFeld%*15)+14+BildVMin%),Farbe%
        IF Farbe% <> 1 THEN
            MID$(FlagFeld$,FlagFeld%,1) = CHR$(Farbe%)
            LINE (0,0) - (0,13),8: LINE (0,0) - (13,0),8
        END IF
        IF Farbe% =  1 THEN
            MID$(FlagFeld$,FlagFeld%,1) = CHR$(Farbe%)
        END IF
        IF InitStart% = 0 AND SBAktiv% = 0 AND BildSound% = 0 THEN
            FOR s% = 480 TO 520 STEP 5
                SOUND s%, s% / 8000
            NEXT s%
        END IF
        IF InitStart% = 0 AND SBAktiv% = 1 AND BildSound% = 0 THEN Pause
        IF InitStart% = 0 AND BildSound% = 1 THEN Pause
        ! retn

'**************************************************************************
'
'              Konfiguration & Startkonstanten
'
'**************************************************************************

SUB MenuFenster public
        MouseOff
        GET (40-BildHMin%, 106-BildVMin%) - (600-BildHMin%, 326-BildVMin%), Tempo%
        VIEW (40, 106) - (600, 326), 7
        DEF SEG = VARSEG(Welcome%(0))
        PUT (0,0), Welcome%, PSET
        COLOR 15, 7
END SUB

SUB MenuWelcome public
        LOCATE 11,8: PRINT "Quadromania ist ein Denkspiel, in dem Sie alle Felder des Spieles  "
        LOCATE 12,8: PRINT "so lange umdrehen mssen, bis sie wieder die Grundfarbe Blau ange- "
        LOCATE 13,8: PRINT "nommen haben. Um die Sache zu erschweren ist die Zuganzahl be-"
        LOCATE 14,8: PRINT "grenzt."
        LOCATE 16,8: PRINT "Die " + Version$ + " von Quadromania ist ausschlielich fr Test-"
        LOCATE 17,8: PRINT "zwecke in Verbindunmg mit dem PBSOUND Toolkit freigegeben."
        LOCATE 19,8: PRINT "Die aktuelleste PBSOUND Version finden sie bei:"
        LOCATE 20,8: PRINT "                 http://www.snafu.de/~pbsound/"
        MouseInit
        MouseView
        MouseOn
        Keypressed
        Mausklick% = 0
        IF A$=CHR$(27) THEN GOTO Ende
        MouseOff
        LOCATE 11,8: PRINT "                 Bitte whlen sie Ihre Spielstufe !!             "
END SUB

SUB MenuConfig public
        FOR i% = 12 TO 15
            LOCATE i%,8: PRINT String$(67,32);
        NEXT i%
        LOCATE 16,8: PRINT String$(63,32)
        LOCATE 17,8: PRINT String$(63,32)
        LOCATE 13,8: PRINT "Bitte whlen Sie Ihre Spielstrke 1-Anfnger bis 9-Profi: ";
        PRINT Spielstark%;
        A$=""
        DO WHILE A$ < CHR$(49) OR A$ > CHR$(57)
            A$=INPUT$(1)
            IF A$=CHR$(27) THEN GOTO Ende
        LOOP
        Spielstark% = ASC(A$)-48
        LOCATE 13,66: PRINT Spielstark%
        LOCATE 15,8: PRINT "Bitte whlen Sie die Anzahl der Spielfarben 2 bis 4 : ... ";
        PRINT Spielfarbe%;
        A$=""
        DO WHILE A$ < CHR$(50) OR A$ > CHR$(52)
            A$=INPUT$(1)
            IF A$=CHR$(27) THEN GOTO Ende
        LOOP
        Spielfarbe% = ASC(A$)-48
        LOCATE 15, 66
        PRINT Spielfarbe%
        SELECT CASE Spielfarbe%
            CASE 2
                IF Spielstark% = 1 THEN ZuegeGes% =  75: Schwierig% =  20
                IF Spielstark% = 2 THEN ZuegeGes% = 100: Schwierig% =   5
                IF Spielstark% = 3 THEN ZuegeGes% = 150: Schwierig% =  -5
                IF Spielstark% = 4 THEN ZuegeGes% = 200: Schwierig% = -15
                IF Spielstark% = 5 THEN ZuegeGes% = 250: Schwierig% = -40
                IF Spielstark% = 6 THEN ZuegeGes% = 300: Schwierig% = -75
                IF Spielstark% = 7 THEN ZuegeGes% = 400: Schwierig% = -115
                IF Spielstark% = 8 THEN ZuegeGes% = 500: Schwierig% = -175
                IF Spielstark% = 9 THEN ZuegeGes% = 750: Schwierig% = -300
            CASE 3
                IF Spielstark% = 1 THEN ZuegeGes% =  75: Schwierig% =  40
                IF Spielstark% = 2 THEN ZuegeGes% = 100: Schwierig% =  10
                IF Spielstark% = 3 THEN ZuegeGes% = 150: Schwierig% = -10
                IF Spielstark% = 4 THEN ZuegeGes% = 200: Schwierig% = -30
                IF Spielstark% = 5 THEN ZuegeGes% = 250: Schwierig% = -65
                IF Spielstark% = 6 THEN ZuegeGes% = 300: Schwierig% = -100
                IF Spielstark% = 7 THEN ZuegeGes% = 400: Schwierig% = -200
                IF Spielstark% = 8 THEN ZuegeGes% = 500: Schwierig% = -350
                IF Spielstark% = 9 THEN ZuegeGes% = 750: Schwierig% = -595
            CASE 4
                IF Spielstark% = 1 THEN ZuegeGes% =  75: Schwierig% =  40
                IF Spielstark% = 2 THEN ZuegeGes% = 100: Schwierig% =  10
                IF Spielstark% = 3 THEN ZuegeGes% = 150: Schwierig% = -10
                IF Spielstark% = 4 THEN ZuegeGes% = 200: Schwierig% = -50
                IF Spielstark% = 5 THEN ZuegeGes% = 250: Schwierig% = -100
                IF Spielstark% = 6 THEN ZuegeGes% = 300: Schwierig% = -200
                IF Spielstark% = 7 THEN ZuegeGes% = 400: Schwierig% = -400
                IF Spielstark% = 8 THEN ZuegeGes% = 500: Schwierig% = -600
                IF Spielstark% = 9 THEN ZuegeGes% = 750: Schwierig% = -800
        END SELECT
        PUT (0,0),Tempo%,PSET
        VIEW (BildHMin%, BildVMin%) - (BildHMax%, BildVMax%)
        COLOR 15,12
        LOCATE 30,1: PRINT STRING$(80,32);
        LOCATE 30,4: PRINT "Bitte warten, das Spielfeld wird regeneriert !!!!";
END SUB

SUB TextKill public
        VIEW (0,462)-(639,479),20
END SUB

'**************************************************************************
'
'
'                    M O U S E  -  R O U T I N E S
'
'
'**************************************************************************

SUB MouseOn public
        ! mov ax, &h01
        ! int &h33
        MausH%      = 0
        MausV%      = 0
        MausKlick%  = 0
        MausDoppel% = 0
END SUB

SUB MouseOff public
        ! mov ax, &h02
        ! int &h33
END SUB

SUB Mausabfrage public
        IF MausFlag% = 1 THEN
            Mausklick%  = 0
            MausButton% = 0
            IF Mausdoppel% > 1 THEN MausDoppel% = 0
            ! mov ax, &h0003
            ! int &h33
            ! mov MausH%, cx
            ! mov MausV%, dx
            ! test bx, &b0000000000000001
            ! jz MausButtonNotPressed
            MausButton% = 1
            MausButtonNotPressed:

            ' linke Knpfe ermitteln
            ! mov ax, &h0006
            ! mov bx, &h0
            ! int &h33
            ! mov MausKlick%, bx
            ! mov MausDoppel% ,bx

            ' rechte Knpfe ermitteln
            ! mov ax, &h0006
            ! mov bx, &h1
            ! int &h33
            ! mov MausRightButton%, bx

            CALL MausUhr                             'vergangende Zeit holen

            MausEnde??? = MausZeit???
            IF MausEnde??? < MausStart??? THEN
                MausDoppel%  = 0
                MausStart??? = 0
            END IF
            IF MausDoppel% = 1 AND MausEnde??? =< MausStart??? + 25 THEN
                MausDoppel% = 2
            END IF
            IF MausDoppel% = 1 THEN
                CALL MausUhr
                MausStart??? = MausZeit???
            END IF
        END IF
        HFeld% = (MausH%-BildHMin%)\15
        VFeld% = (MausV%-BildVMin%)\15
        ! inc HFeld%
        ! inc VFeld%
END SUB

SUB MausUhr public
        IF MausFlag% = 1 THEN
            ! mov ah, &h2c
            ! int &h21
            ! mov MausSekunde?, dh
            ! mov MausMilli?, dl
            ! mov MausMinute?, cl
            Mauszeit??? = (MausMinute?*6000) + (MausSekunde?*100) + MausMilli?
        END IF
END SUB

SUB MouseInit public
        ! mov ax, &H00
        ! int &h33
        MausFlag% = 1
END SUB

SUB MouseReset public
        ! mov ax, &h0021
        ! int &h33
END SUB

SUB MouseView public
        ! mov ax, &h07
        ! mov cx, BildHMin%
        ! mov dx, BildHMax%
        ! int &h33
        ! mov ax, &h08
        ! mov cx, BildVMin%
        ! mov dx, BildVMax%
        ! int &h33
END SUB

SUB KeyPressed public
        MausAbfrage
        A$ = "": MausButton% = 0
        DO UNTIL LEN(A$) > 0 OR Mausklick% > 0
            MausAbfrage
            A$ = UCASE$(INKEY$)
        WEND
END SUB

SUB Pause public
        SBDelayFlag% = 0
        SBDelay& = 15000
        ! mov dx, SBDelay&[00]
        ! mov cx, SBDelay&[02]
        ! lea bx, SBDelayFlag%
        ! push ds
        ! pop es
        ! mov ax, &h8300                ;ah = 83h
        ! int &h15                      ;Warten mit Genauigkeit 1 ms
        SBDelayWait:
        ! test SBDelayFlag%, &b10000000
        ! je SBDelayWait
END SUB

'************************************************************************
'
'                            H I L F E  &  F E H L E R
'
'************************************************************************

SUB TitelLeiste public
        COLOR 11,0
        PRINT
        PRINT "Quadromania PC "; TAB(60);" (c) 1993/96 "; Author$;
        PRINT "Alle Rechte vorbehalten"; TAB(69); Version$;
        PRINT
        COLOR 7,0
END SUB

SUB Hilfe public
        TitelLeiste
        PRINT "  Syntax:  QUADROM [/x] - Parameter
        PRINT
        PRINT TAB(15); "/?     - Ausgabe dieses Hilfetextes"
        PRINT TAB(15); "/S     - Sound aus"
        PRINT TAB(15); "/MONO  - monochrome Bildausgabe"
        PRINT
        PRINT "  Beispiel: QUADROM /mono"
END SUB

SUB DiskLog public
        NL$ = CHR$(13) + CHR$(10)
        OPEN QDir$ + "QUADROM.LOG" FOR BINARY AS #1
        SEEK #1, LOF(1)
        IF LOF(1) = 0 THEN
            PUT$ #1, NL$ + "              Quadromania PC  Logbuch-File fr Schwierigkeitsstufen"
            PUT$ #1, NL$ + STRING$(79,"-") + NL$ + NL$
        END IF
        PUT$ #1, "Datum: " + DATE$ + "    Uhrzeit:  " + TIME$ + "       " + Version$ + NL$ + NL$
        PUT$ #1, "       "
        PUT$ #1, "Spielstrke: " + STR$(SpielStark%) + "   "
        PUT$ #1, "Spielfarben: " + STR$(SpielFarbe%) + "   "
        PUT$ #1, "max. Zge: " + STR$((ZuegeGes% *(Spielfarbe%-1)) + Schwierig%) + "  "
        PUT$ #1, "gem. Zge: " + STR$(Zug%-1) + NL$
        PUT$ #1, "       "
        IF FlagFeld$ = String$(1218,1) THEN
            PUT$  #1, "erfolgreich"
        ELSE
            PUT$  #1, "nicht gelst"
        END IF
        PUT$ #1, NL$ + NL$
        CLOSE #1
END SUB

Fehler:
        GOTO Ende


'***************************************************************************
'   Fading Routinen
'***************************************************************************

SUB ScreenOut public
        LOCAL VGAPaletteSeg??, VGAPaletteOff??
        VGAPaletteSeg?? = VARSEG(VGAPalette(0))
        VGAPaletteOff?? = VARPTR(VGAPalette(0))
        ! mov dx, &h03C8
        ! mov al, 0
        ! out dx, al
        ! push es
        ! push di
        ! xor ax, ax                     ;' Null fr VGA-Palette und DAC
        ! mov cx, PalettenMax%           ;' Port
        ! mov dx, &h03C9
        ! mov es, VGAPaletteSeg??
        ! mov di, VGAPaletteOff??
        ScreenOutSchleife:
        ! mov word ptr es:[di], ax       ;' Array lschen
        ! mov al, 0
        ! out dx, al                     ;' Null in DAC schreiben
        ! add di, 2
        ! loop ScreenOutSchleife
        ! pop di
        ! pop es
END SUB

SUB BackupPalette public
        LOCAL VGAPaletteSeg??, VGAPaletteOff??
        VGAPaletteSeg?? = VARSEG(VGAPalette(0))
        VGAPaletteOff?? = VARPTR(VGAPalette(0))
        ! mov dx, &h03C7                 ;'DAC-Palette auf Null
        ! mov al, 0
        ! out dx, al
        ! mov cx, PalettenMax%
        ! push es
        ! push di
        ! xor ax, ax
        ! mov dx, &h03C9
        ! mov es, VGAPaletteSeg??
        ! mov di, VGAPaletteOff??
        GetPaletteSchleife:
        ! in al, dx
        ! mov word ptr es:[di], ax       ;' Array lschen
        ! add di, 2
        ! loop GetPaletteSchleife
        ! pop di
        ! pop es
        FOR i% = 0 TO PalettenMax%
            VGABackup(i%) = VGAPalette(i%)
        NEXT i%
END SUB

SUB SetPalette public
        LOCAL VGAPaletteSeg??, VGAPaletteOff??
        VGAPaletteSeg?? = VARSEG(VGAPalette(0))
        VGAPaletteOff?? = VARPTR(VGAPalette(0))
        ! mov dx, &h03C8                 ;'DAC-Palette auf Null
        ! mov al, 0
        ! out dx, al
        ! call WaitRetrace               ;'auf VRetrace warten
        ! push di
        ! push es
        ! mov dx, &h03C9                 ;'DAC adressieren
        ! mov cx, 126                    ;'die ersten 42 Paletten
        ! mov es, VGAPaletteSeg??
        ! mov di, VGAPaletteOff??
        FirstPalette:
        ! mov al, byte ptr es:[di]
        ! out dx, al
        ! add di, 2
        ! loop FirstPalette
        ! call WaitRetrace
        ! mov dx, &h03C9
        ! mov cx, 129                    ;'den Rest durchschieben
        SecondPalette:
        ! mov al, byte ptr es:[di]
        ! out dx, al
        ! add di, 2
        ! loop SecondPalette
        ! pop es
        ! pop di
        ! jmp PaletteEnde
        WaitRetrace:                      'Warten auf VerRetrace
        ! mov dx, &h03da
        ! in al, dx
        ! test al, 8
        ! jne WaitRetrace                ;'vorbei??
        SetPalette1:                      'jetzt wieder warten
        ! in al, dx
        ! test al, 8
        ! je SetPalette1
        ! retn
        PaletteEnde:
END SUB

SUB FadingOut public
        LOCAL VGAPaletteSeg??, VGAPaletteOff??
        LOCAL Abstufung?
        VGAPaletteSeg?? = VARSEG(VGAPalette(0))
        VGAPaletteOff?? = VARPTR(VGAPalette(0))
        Abstufung? = 63
        ! push es
        ! push di
        ReduzeStufen:
        ! xor bx, bx                     ;'bx = Zero fr CMP
        ! mov cx, PalettenMax%
        ! mov es, VGAPaletteSeg??
        ! mov di, VGAPaletteOff??
        FadingOutSchleife:
        ! mov ax, word ptr es:[di]       ;' Wert holen
        ! cmp ax, bx
        ! jz DecrementNo                 ;' wenn noch nicht Zero dann
        ! dec ax                         ;' um 1 erniedrigen
        ! mov word ptr es:[di], ax       ;' und zurck ins Array
        DecrementNo:
        ! add di, 2                      ;' Zeiger um 2 erhhen, da Integer
        ! loop FadingOutSchleife
        CALL SetPalette
        ! dec Abstufung?                 ;' erniedrige Abstufung
        ! jnz ReduzeStufen               ;' bereits Zero, ansonsten weiter
        ! pop di
        ! pop es
END SUB

SUB FadingIn public
        LOCAL VGAPaletteSeg??, VGAPaletteOff??
        LOCAL VGABackupSeg??, VGABackupOff??
        LOCAL Abstufung?
        VGAPaletteSeg?? = VARSEG(VGAPalette(0))
        VGAPaletteOff?? = VARPTR(VGAPalette(0))
        VGABackupSeg?? = VARSEG(VGABackup(0))
        VGABackupOff?? = VARPTR(VGABackup(0))
        ! push es
        ! push di
        ! mov Abstufung?, 63
        FadingInReduzeStufen:
        ! xor ax, ax
        ! xor dx, dx
        ! mov cx, PalettenMax%
        FadingInSchleife:
        ! mov es, VGABackupSeg??         ;'Zeiger auf VGA-Backup
        ! mov di, VGABackupOff??
        ! add di, dx                     ;'Index erhhen
        ! mov bx, word ptr es:[di]       ;'Wert vom Backup holen
        ! mov es, VGAPaletteSeg??        ;'Zeiger auf VGA-Palette
        ! mov di, VGAPaletteOff??
        ! add di, dx                     ;'Index erhhen
        ! mov ax, word ptr es:[di]       ;'aktuellen Wert holen
        ! cmp ax, bx                     ;'vergleichen
        ! jnc FadingInWeiter             ;'wenn noch kleiner
        ! inc ax                         ;'dann erhhen
        FadingInWeiter:
        ! mov word ptr es:[di], ax       ;'und wieder zurck in das VGA-Array
        ! add dx, 2
        ! loop FadingInSchleife
        CALL SetPalette
        ! dec Abstufung?
        ! jnz FadingInReduzeStufen
        ! pop di
        ! pop es
END SUB

'***************************************************************************
'   Laden der Schriftfont's
'***************************************************************************

SUB LoadFont (Font$,FontHigh%) public
        FileHandle% = FREEFILE
        OPEN "B", FileHandle%, (Font$)
        FileLen??? = LOF(FileHandle%)
        SEEK FileHandle%, 1
        GET$ FileHandle%, FileLen???, NewFont$
        CLOSE FileHandle%
        FontHoehe% = FontHigh%
        FontPTR??? = STRPTR32(NewFont$)
        ! push es
        ! push bp
        ! mov  ax, &h0012
        ! int &h10
        ! mov  ah, &h11
        ! mov  al, &h21
        ! mov  bl, &h02
        ! mov  cx, 16
        ! mov  es, FontPTR???[02]
        ! mov  bp, FontPTR???[00]
        ! int  &h10
        ! pop  bp
        ! pop  es
END SUB

